Index: /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OFF_SRC/dtadyn.F90
===================================================================
--- /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OFF_SRC/dtadyn.F90	(revision 7521)
+++ /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OFF_SRC/dtadyn.F90	(revision 7522)
@@ -456,75 +321,353 @@
             ALLOCATE( uslpdta (jpi,jpj,jpk,2), vslpdta (jpi,jpj,jpk,2),    &
             &         wslpidta(jpi,jpj,jpk,2), wslpjdta(jpi,jpj,jpk,2), STAT=ierr2 )
-         ELSE
-            ALLOCATE( uslpnow (jpi,jpj,jpk)  , vslpnow (jpi,jpj,jpk)  ,    &
-            &         wslpinow(jpi,jpj,jpk)  , wslpjnow(jpi,jpj,jpk)  , STAT=ierr2 )
-         ENDIF 
-         IF( ierr2 > 0 ) THEN
-            CALL ctl_stop( 'dta_dyn_init : unable to allocate slope arrays' )   ;   RETURN
+            !
+            IF( ierr2 > 0 )  THEN
+               CALL ctl_stop( 'dta_dyn_init : unable to allocate slope arrays' )   ;   RETURN
+            ENDIF
          ENDIF
       ENDIF
-      IF( ln_dynwzv ) THEN                  ! slopes 
-         IF( sf_dyn(jf_uwd)%ln_tint ) THEN      ! time interpolation
-            ALLOCATE( wdta(jpi,jpj,jpk,2), STAT=ierr3 )
-         ELSE
-            ALLOCATE( wnow(jpi,jpj,jpk)  , STAT=ierr3 )
-         ENDIF 
-         IF( ierr3 > 0 ) THEN
-            CALL ctl_stop( 'dta_dyn_init : unable to allocate wdta arrays' )   ;   RETURN
-         ENDIF
-      ENDIF
-      !
-      CALL dta_dyn( nit000 )
-      !
-   END SUBROUTINE dta_dyn_init
-
-   SUBROUTINE dta_dyn_wzv( pu, pv, pw )
-      !!----------------------------------------------------------------------
-      !!                    ***  ROUTINE wzv  ***
-      !!
-      !! ** Purpose :   Compute the now vertical velocity after the array swap
-      !!
-      !! ** Method  : - compute the now divergence given by :
-      !!         * z-coordinate ONLY !!!!
-      !!         hdiv = 1/(e1t*e2t) [ di(e2u  u) + dj(e1v  v) ]
-      !!     - Using the incompressibility hypothesis, the vertical
-      !!      velocity is computed by integrating the horizontal divergence
-      !!      from the bottom to the surface.
-      !!        The boundary conditions are w=0 at the bottom (no flux).
-      !!----------------------------------------------------------------------
-      USE oce, ONLY:  zhdiv => hdivn
-      !
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in   ) :: pu, pv    !:  horizontal velocities
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(  out) :: pw        !:  vertical velocity
-      !!
-      INTEGER  ::  ji, jj, jk
-      REAL(wp) ::  zu, zu1, zv, zv1, zet
-      !!----------------------------------------------------------------------
-      !
-      ! Computation of vertical velocity using horizontal divergence
-      zhdiv(:,:,:) = 0._wp
-      DO jk = 1, jpkm1
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               zu  = pu(ji  ,jj  ,jk) * umask(ji  ,jj  ,jk) * e2u(ji  ,jj  ) * fse3u(ji  ,jj  ,jk)
-               zu1 = pu(ji-1,jj  ,jk) * umask(ji-1,jj  ,jk) * e2u(ji-1,jj  ) * fse3u(ji-1,jj  ,jk)
-               zv  = pv(ji  ,jj  ,jk) * vmask(ji  ,jj  ,jk) * e1v(ji  ,jj  ) * fse3v(ji  ,jj  ,jk)
-               zv1 = pv(ji  ,jj-1,jk) * vmask(ji  ,jj-1,jk) * e1v(ji  ,jj-1) * fse3v(ji  ,jj-1,jk)
-               zet = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
-               zhdiv(ji,jj,jk) = ( zu - zu1 + zv - zv1 ) * zet 
+      !
+      IF( lk_vvl ) THEN
+        IF( .NOT. sf_dyn(jf_uwd)%ln_clim .AND. ln_rsttr .AND.    &                     ! Restart: read in restart file
+           iom_varid( numrtr, 'sshn', ldstop = .FALSE. ) > 0 ) THEN
+           IF(lwp) WRITE(numout,*) ' sshn forcing fields read in the restart file for initialisation'
+           CALL iom_get( numrtr, jpdom_autoglo, 'sshn', sshn(:,:)   )
+           CALL iom_get( numrtr, jpdom_autoglo, 'sshb', sshb(:,:)   )
+        ELSE
+           IF(lwp) WRITE(numout,*) ' sshn forcing fields read in the restart file for initialisation'
+           CALL iom_open( 'restart', inum )
+           CALL iom_get( inum, jpdom_autoglo, 'sshn', sshn(:,:)   )
+           CALL iom_get( inum, jpdom_autoglo, 'sshb', sshb(:,:)   )
+           CALL iom_close( inum )                                        ! close file
+        ENDIF
+        !
+        DO jk = 1, jpkm1
+           fse3t_n(:,:,jk) = e3t_0(:,:,jk) * ( 1._wp + sshn(:,:) * tmask(:,:,1) / ( ht_0(:,:) + 1.0 - tmask(:,:,1) ) )
+        ENDDO
+        fse3t_a(:,:,jpk) = e3t_0(:,:,jpk)
+
+        ! Horizontal scale factor interpolations
+        ! --------------------------------------
+        CALL dom_vvl_interpol( fse3t_n(:,:,:), fse3u_n(:,:,:), 'U' )
+        CALL dom_vvl_interpol( fse3t_n(:,:,:), fse3v_n(:,:,:), 'V' )
+
+        ! Vertical scale factor interpolations
+        ! ------------------------------------
+        CALL dom_vvl_interpol( fse3t_n(:,:,:), fse3w_n(:,:,:), 'W' )
+  
+        fse3t_b(:,:,:)  = fse3t_n(:,:,:)
+        fse3u_b(:,:,:)  = fse3u_n(:,:,:)
+        fse3v_b(:,:,:)  = fse3v_n(:,:,:)
+
+        ! t- and w- points depth
+        ! ----------------------
+        fsdept_n(:,:,1) = 0.5_wp * fse3w_n(:,:,1)
+        fsdepw_n(:,:,1) = 0.0_wp
+
+        DO jk = 2, jpk
+           DO jj = 1,jpj
+              DO ji = 1,jpi
+                !    zcoef = (tmask(ji,jj,jk) - wmask(ji,jj,jk))   ! 0 everywhere
+                !    tmask = wmask, ie everywhere expect at jk = mikt
+                                                                   ! 1 for jk =
+                                                                   ! mikt
+                 zcoef = (tmask(ji,jj,jk) - wmask(ji,jj,jk))
+                 fsdepw_n(ji,jj,jk) = fsdepw_n(ji,jj,jk-1) + fse3t_n(ji,jj,jk-1)
+                 fsdept_n(ji,jj,jk) =      zcoef  * ( fsdepw_n(ji,jj,jk  ) + 0.5 * fse3w_n(ji,jj,jk))  &
+                     &                + (1-zcoef) * ( fsdept_n(ji,jj,jk-1) + fse3w_n(ji,jj,jk))
+              END DO
+           END DO
+        END DO
+
+        fsdept_b(:,:,:) = fsdept_n(:,:,:)
+        fsdepw_b(:,:,:) = fsdepw_n(:,:,:)
+        !
+      ENDIF
+      !
+      IF( ln_dynrnf .AND. ln_dynrnf_depth ) THEN       ! read depht over which runoffs are distributed
+         IF(lwp) WRITE(numout,*) 
+         IF(lwp) WRITE(numout,*) ' read in the file depht over which runoffs are distributed'
+         CALL iom_open ( "runoffs", inum )                           ! open file
+         CALL iom_get  ( inum, jpdom_data, 'rodepth', h_rnf )   ! read the river mouth array
+         CALL iom_close( inum )                                        ! close file
+         !
+         nk_rnf(:,:) = 0                               ! set the number of level over which river runoffs are applied
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               IF( h_rnf(ji,jj) > 0._wp ) THEN
+                  jk = 2
+                  DO WHILE ( jk /= mbkt(ji,jj) .AND. gdept_0(ji,jj,jk) < h_rnf(ji,jj) ) ;  jk = jk + 1
+                  END DO
+                  nk_rnf(ji,jj) = jk
+               ELSEIF( h_rnf(ji,jj) == -1._wp   ) THEN   ;  nk_rnf(ji,jj) = 1
+               ELSEIF( h_rnf(ji,jj) == -999._wp ) THEN   ;  nk_rnf(ji,jj) = mbkt(ji,jj)
+               ELSE
+                  CALL ctl_stop( 'sbc_rnf_init: runoff depth not positive, and not -999 or -1, rnf value in file fort.999'  )
+                  WRITE(999,*) 'ji, jj, h_rnf(ji,jj) :', ji, jj, h_rnf(ji,jj)
+               ENDIF
             END DO
          END DO
+         DO jj = 1, jpj                                ! set the associated depth
+            DO ji = 1, jpi
+               h_rnf(ji,jj) = 0._wp
+               DO jk = 1, nk_rnf(ji,jj)
+                  h_rnf(ji,jj) = h_rnf(ji,jj) + fse3t(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+      ELSE                                       ! runoffs applied at the surface
+         nk_rnf(:,:) = 1
+         h_rnf (:,:) = fse3t(:,:,1)
+      ENDIF
+      nkrnf_max = MAXVAL( nk_rnf(:,:) )
+      hrnf_max = MAXVAL( h_rnf(:,:) )
+      IF( lk_mpp )  THEN
+         CALL mpp_max( nkrnf_max )                 ! max over the  global domain
+         CALL mpp_max( hrnf_max )                 ! max over the  global domain
+      ENDIF
+      IF(lwp) WRITE(numout,*) ' '
+      IF(lwp) WRITE(numout,*) ' max depht of runoff : ', hrnf_max,'    max level  : ', nkrnf_max
+      IF(lwp) WRITE(numout,*) ' '
+      !
+      CALL dta_dyn( nit000 )
+      !
+   END SUBROUTINE dta_dyn_init
+
+   SUBROUTINE dta_dyn_swp( kt )
+     !!---------------------------------------------------------------------
+      !!                    ***  ROUTINE dta_dyn_swp  ***
+      !!
+      !! ** Purpose : Swap and the data and compute the vertical scale factor at U/V/W point
+      !!              and the depht
+      !!
+      !!---------------------------------------------------------------------
+      INTEGER, INTENT(in) :: kt       ! time step
+      INTEGER             :: ji, jj, jk
+      REAL(wp)            :: zcoef
+      !
+      !!---------------------------------------------------------------------
+
+      IF( kt == nit000 ) THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'ssh_swp : Asselin time filter and swap of sea surface height'
+         IF(lwp) WRITE(numout,*) '~~~~~~~ '
+      ENDIF
+
+      sshb(:,:) = sshn(:,:) + atfp * ( sshb(:,:) - 2 * sshn(:,:) + ssha(:,:))  ! before <-- now filtered
+      sshn(:,:) = ssha(:,:)
+
+      fse3t_n(:,:,:) = fse3t_a(:,:,:)
+
+      ! Reconstruction of all vertical scale factors at now and before time steps
+      ! =============================================================================
+
+      ! Horizontal scale factor interpolations
+      ! --------------------------------------
+      CALL dom_vvl_interpol( fse3t_n(:,:,:), fse3u_n(:,:,:), 'U' )
+      CALL dom_vvl_interpol( fse3t_n(:,:,:), fse3v_n(:,:,:), 'V' )
+
+      ! Vertical scale factor interpolations
+      ! ------------------------------------
+      CALL dom_vvl_interpol( fse3t_n(:,:,:), fse3w_n (:,:,:), 'W' )
+
+      fse3t_b(:,:,:)  = fse3t_n(:,:,:)
+      fse3u_b(:,:,:)  = fse3u_n(:,:,:)
+      fse3v_b(:,:,:)  = fse3v_n(:,:,:)
+
+      ! t- and w- points depth
+      ! ----------------------
+      fsdept_n(:,:,1) = 0.5_wp * fse3w_n(:,:,1)
+      fsdepw_n(:,:,1) = 0.0_wp
+
+      DO jk = 2, jpk
+         DO jj = 1,jpj
+            DO ji = 1,jpi
+                 zcoef = (tmask(ji,jj,jk) - wmask(ji,jj,jk))
+                 fsdepw_n(ji,jj,jk) = fsdepw_n(ji,jj,jk-1) + fse3t_n(ji,jj,jk-1)
+                 fsdept_n(ji,jj,jk) =      zcoef  * ( fsdepw_n(ji,jj,jk  ) + 0.5 * fse3w_n(ji,jj,jk))  &
+                     &                + (1-zcoef) * ( fsdept_n(ji,jj,jk-1) + fse3w_n(ji,jj,jk))
+              END DO
+           END DO
+        END DO
+
+      fsdept_b(:,:,:) = fsdept_n(:,:,:)
+      fsdepw_b(:,:,:) = fsdepw_n(:,:,:)
+
+      !
+   END SUBROUTINE dta_dyn_swp
+
+   SUBROUTINE dta_dyn_ssh( kt, phdivtr, psshb,  pemp, pssha, pe3ta )
+      !!----------------------------------------------------------------------
+      !!                ***  ROUTINE dta_dyn_wzv  ***
+      !!                   
+      !! ** Purpose :   compute the after ssh (ssha) and the now vertical velocity
+      !!
+      !! ** Method  : Using the incompressibility hypothesis, 
+      !!        - the ssh increment is computed by integrating the horizontal divergence 
+      !!          and multiply by the time step.
+      !!
+      !!        - compute the after scale factor : repartition of ssh INCREMENT proportionnaly
+      !!                                           to the level thickness ( z-star case )
+      !!
+      !!        - the vertical velocity is computed by integrating the horizontal divergence  
+      !!          from the bottom to the surface minus the scale factor evolution.
+      !!          The boundary conditions are w=0 at the bottom (no flux)
+      !!
+      !! ** action  :   ssha / e3t_a / wn
+      !!
+      !! Reference  : Leclair, M., and G. Madec, 2009, Ocean Modelling.
+      !!----------------------------------------------------------------------
+      !! * Arguments
+      INTEGER,                                   INTENT(in )    :: kt        !  time-step
+      REAL(wp), DIMENSION(jpi,jpj,jpk)          , INTENT(in )   :: phdivtr   ! horizontal divergence transport
+      REAL(wp), DIMENSION(jpi,jpj)    , OPTIONAL, INTENT(in )   :: psshb     ! now ssh
+      REAL(wp), DIMENSION(jpi,jpj)    , OPTIONAL, INTENT(in )   :: pemp      ! evaporation minus precipitation
+      REAL(wp), DIMENSION(jpi,jpj)    , OPTIONAL, INTENT(inout) :: pssha     ! after ssh
+      REAL(wp), DIMENSION(jpi,jpj,jpk), OPTIONAL, INTENT(out)   :: pe3ta     ! after vertical scale factor
+      !! * Local declarations
+      INTEGER                       :: jk
+      REAL(wp), DIMENSION(jpi,jpj)  :: zhdiv  
+      REAL(wp)  :: z2dt  
+      !!----------------------------------------------------------------------
+      
+      !
+      z2dt = 2._wp * rdt
+      !
+      zhdiv(:,:) = 0._wp
+      DO jk = 1, jpkm1
+         zhdiv(:,:) = zhdiv(:,:) +  phdivtr(:,:,jk) * tmask(:,:,jk)
       END DO
-      CALL lbc_lnk( zhdiv, 'T', 1. )      ! Lateral boundary conditions on zhdiv
-      !
-      ! computation of vertical velocity from the bottom
-      pw(:,:,jpk) = 0._wp
-      DO jk = jpkm1, 1, -1
-         pw(:,:,jk) = pw(:,:,jk+1) - fse3t(:,:,jk) * zhdiv(:,:,jk)
+      !                                                ! Sea surface  elevation time-stepping
+      pssha(:,:) = ( psshb(:,:) - z2dt * ( r1_rau0 * pemp(:,:)  + zhdiv(:,:) ) ) * ssmask(:,:)
+      !                                                 ! 
+      !                                                 ! After acale factors at t-points ( z_star coordinate )
+      DO jk = 1, jpkm1
+        pe3ta(:,:,jk) = e3t_0(:,:,jk) * ( 1._wp + pssha(:,:) * tmask(:,:,1) / ( ht_0(:,:) + 1.0 - tmask(:,:,1) ) )
       END DO
       !
-   END SUBROUTINE dta_dyn_wzv
-
-   SUBROUTINE dta_dyn_slp( kt, pts, puslp, pvslp, pwslpi, pwslpj )
+   END SUBROUTINE dta_dyn_ssh
+
+
+   SUBROUTINE dta_dyn_hrnf
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE sbc_rnf  ***
+      !!
+      !! ** Purpose :   update the horizontal divergence with the runoff inflow
+      !!
+      !! ** Method  :
+      !!                CAUTION : rnf is positive (inflow) decreasing the
+      !!                          divergence and expressed in m/s
+      !!
+      !! ** Action  :   phdivn   decreased by the runoff inflow
+      !!----------------------------------------------------------------------
+      !!
+      INTEGER  ::   ji, jj, jk   ! dummy loop indices
+      !!----------------------------------------------------------------------
+      !
+      DO jj = 1, jpj                   ! update the depth over which runoffs are distributed
+         DO ji = 1, jpi
+            h_rnf(ji,jj) = 0._wp
+            DO jk = 1, nk_rnf(ji,jj)                           ! recalculates h_rnf to be the depth in metres
+                h_rnf(ji,jj) = h_rnf(ji,jj) + fse3t(ji,jj,jk)   ! to the bottom of the relevant grid box
+            END DO
+        END DO
+      END DO
+      !
+   END SUBROUTINE dta_dyn_hrnf
+
+
+
+   SUBROUTINE dta_dyn_slp( kt )
+      !!---------------------------------------------------------------------
+      !!                    ***  ROUTINE dta_dyn_slp  ***
+      !!
+      !! ** Purpose : Computation of slope
+      !!
+      !!---------------------------------------------------------------------
+      USE oce, ONLY:  zts => tsa 
+      !
+      INTEGER,  INTENT(in) :: kt       ! time step
+      !
+      INTEGER  ::   ji, jj     ! dummy loop indices
+      REAL(wp) ::   ztinta     ! ratio applied to after  records when doing time interpolation
+      REAL(wp) ::   ztintb     ! ratio applied to before records when doing time interpolation
+      INTEGER  ::   iswap
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: zuslp, zvslp, zwslpi, zwslpj
+      !!---------------------------------------------------------------------
+      !
+      CALL wrk_alloc(jpi, jpj, jpk, zuslp, zvslp, zwslpi, zwslpj )
+      !
+      IF( sf_dyn(jf_tem)%ln_tint ) THEN    ! Computes slopes (here avt is used as workspace)                       
+         IF( kt == nit000 ) THEN
+            zts(:,:,:,jp_tem) = sf_dyn(jf_tem)%fdta(:,:,:,1) * tmask(:,:,:)   ! temperature
+            zts(:,:,:,jp_sal) = sf_dyn(jf_sal)%fdta(:,:,:,1) * tmask(:,:,:)   ! salinity 
+            avt(:,:,:)        = sf_dyn(jf_avt)%fdta(:,:,:,1) * tmask(:,:,:)   ! vertical diffusive coef.
+            CALL compute_slopes( kt, zts, zuslp, zvslp, zwslpi, zwslpj )
+            uslpdta (:,:,:,1) = zuslp (:,:,:) 
+            vslpdta (:,:,:,1) = zvslp (:,:,:) 
+            wslpidta(:,:,:,1) = zwslpi(:,:,:) 
+            wslpjdta(:,:,:,1) = zwslpj(:,:,:) 
+            !
+            zts(:,:,:,jp_tem) = sf_dyn(jf_tem)%fdta(:,:,:,2) * tmask(:,:,:)   ! temperature
+            zts(:,:,:,jp_sal) = sf_dyn(jf_sal)%fdta(:,:,:,2) * tmask(:,:,:)   ! salinity 
+            avt(:,:,:)        = sf_dyn(jf_avt)%fdta(:,:,:,2) * tmask(:,:,:)   ! vertical diffusive coef.
+            CALL compute_slopes( kt, zts, zuslp, zvslp, zwslpi, zwslpj )
+            uslpdta (:,:,:,2) = zuslp (:,:,:) 
+            vslpdta (:,:,:,2) = zvslp (:,:,:) 
+            wslpidta(:,:,:,2) = zwslpi(:,:,:) 
+            wslpjdta(:,:,:,2) = zwslpj(:,:,:) 
+         ELSE
+           ! 
+           iswap = 0
+           IF( sf_dyn(jf_tem)%nrec_a(2) - nprevrec /= 0 )  iswap = 1
+           IF( nsecdyn > sf_dyn(jf_tem)%nrec_b(2) .AND. iswap == 1 )  THEN    ! read/update the after data
+              IF(lwp) WRITE(numout,*) ' Compute new slopes at kt = ', kt
+              uslpdta (:,:,:,1) =  uslpdta (:,:,:,2)         ! swap the data
+              vslpdta (:,:,:,1) =  vslpdta (:,:,:,2)  
+              wslpidta(:,:,:,1) =  wslpidta(:,:,:,2) 
+              wslpjdta(:,:,:,1) =  wslpjdta(:,:,:,2) 
+              !
+              zts(:,:,:,jp_tem) = sf_dyn(jf_tem)%fdta(:,:,:,2) * tmask(:,:,:)   ! temperature
+              zts(:,:,:,jp_sal) = sf_dyn(jf_sal)%fdta(:,:,:,2) * tmask(:,:,:)   ! salinity 
+              avt(:,:,:)        = sf_dyn(jf_avt)%fdta(:,:,:,2) * tmask(:,:,:)   ! vertical diffusive coef.
+              CALL compute_slopes( kt, zts, zuslp, zvslp, zwslpi, zwslpj )
+              !
+              uslpdta (:,:,:,2) = zuslp (:,:,:) 
+              vslpdta (:,:,:,2) = zvslp (:,:,:) 
+              wslpidta(:,:,:,2) = zwslpi(:,:,:) 
+              wslpjdta(:,:,:,2) = zwslpj(:,:,:) 
+            ENDIF
+         ENDIF
+      ENDIF
+      !
+      IF( sf_dyn(jf_tem)%ln_tint )  THEN
+         ztinta =  REAL( nsecdyn - sf_dyn(jf_tem)%nrec_b(2), wp )  &
+            &    / REAL( sf_dyn(jf_tem)%nrec_a(2) - sf_dyn(jf_tem)%nrec_b(2), wp )
+         ztintb =  1. - ztinta
+#if defined key_ldfslp && ! defined key_c1d
+         uslp (:,:,:) = ztintb * uslpdta (:,:,:,1)  + ztinta * uslpdta (:,:,:,2)  
+         vslp (:,:,:) = ztintb * vslpdta (:,:,:,1)  + ztinta * vslpdta (:,:,:,2)  
+         wslpi(:,:,:) = ztintb * wslpidta(:,:,:,1)  + ztinta * wslpidta(:,:,:,2)  
+         wslpj(:,:,:) = ztintb * wslpjdta(:,:,:,1)  + ztinta * wslpjdta(:,:,:,2)  
+#endif
+      ELSE
+         zts(:,:,:,jp_tem) = sf_dyn(jf_tem)%fnow(:,:,:) * tmask(:,:,:)   ! temperature
+         zts(:,:,:,jp_sal) = sf_dyn(jf_sal)%fnow(:,:,:) * tmask(:,:,:)   ! salinity 
+         avt(:,:,:)        = sf_dyn(jf_avt)%fnow(:,:,:) * tmask(:,:,:)   ! vertical diffusive coef.
+         CALL compute_slopes( kt, zts, zuslp, zvslp, zwslpi, zwslpj )
+         !
+#if defined key_ldfslp && ! defined key_c1d
+         uslp (:,:,:) = zuslp (:,:,:)
+         vslp (:,:,:) = zvslp (:,:,:)
+         wslpi(:,:,:) = zwslpi(:,:,:)
+         wslpj(:,:,:) = zwslpj(:,:,:)
+#endif
+      ENDIF
+      !
+      CALL wrk_dealloc(jpi, jpj, jpk, zuslp, zvslp, zwslpi, zwslpj )
+      !
+   END SUBROUTINE dta_dyn_slp
+
+   SUBROUTINE compute_slopes( kt, pts, puslp, pvslp, pwslpi, pwslpj )
       !!---------------------------------------------------------------------
       !!                    ***  ROUTINE dta_dyn_slp  ***
@@ -568,5 +711,6 @@
 #endif
       !
-   END SUBROUTINE dta_dyn_slp
+   END SUBROUTINE compute_slopes
+
    !!======================================================================
 END MODULE dtadyn
Index: /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OFF_SRC/nemogcm.F90
===================================================================
--- /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OFF_SRC/nemogcm.F90	(revision 7521)
+++ /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OFF_SRC/nemogcm.F90	(revision 7522)
@@ -34,5 +34,5 @@
    USE trcstp          ! passive tracer time-stepping      (trc_stp routine)
    USE dtadyn          ! Lecture and interpolation of the dynamical fields
-   !              ! I/O & MPP
+   !                   ! I/O & MPP
    USE iom             ! I/O library
    USE in_out_manager  ! I/O manager
@@ -50,5 +50,4 @@
    USE trcnam
    USE trcrst
-   USE diaptr         ! Need to initialise this as some variables are used in if statements later
 
    IMPLICIT NONE
@@ -94,13 +93,14 @@
       istp = nit000
       ! 
-      CALL iom_init( cxios_context )            ! iom_put initialization (must be done after nemo_init for AGRIF+XIOS+OASIS)
-      ! 
       DO WHILE ( istp <= nitend .AND. nstop == 0 )    ! time stepping
          !
-         IF( istp /= nit000 )   CALL day      ( istp )         ! Calendar (day was already called at nit000 in day_init)
-                                CALL iom_setkt( istp - nit000 + 1, "nemo" )   ! say to iom that we are at time step kstp
-                                CALL dta_dyn  ( istp )         ! Interpolation of the dynamical fields
-                                CALL trc_stp  ( istp )         ! time-stepping
-                                CALL stp_ctl  ( istp, indic )  ! Time loop: control and print
+         IF( istp == nit000 )  CALL iom_init( cxios_context )            ! iom_put initialization
+         IF( istp /= nit000 )   CALL day        ( istp )         ! Calendar (day was already called at nit000 in day_init)
+                                CALL iom_setkt  ( istp - nit000 + 1, cxios_context )   ! say to iom that we are at time step kstp
+                                CALL trc_rst_opn( istp )         ! Open tracer                                !   restart file
+                                CALL dta_dyn    ( istp )         ! Interpolation of the dynamical fields
+                                CALL trc_stp    ( istp )         ! time-stepping
+         IF( lk_vvl )           CALL dta_dyn_swp( istp )         ! swap of sea surface height and vertical scale factors
+                                CALL stp_ctl    ( istp, indic )  ! Time loop: control and print
          istp = istp + 1
          IF( lk_mpp )   CALL mpp_max( nstop )
@@ -265,19 +265,20 @@
       IF( nn_timing == 1 )  CALL timing_start( 'nemo_init')
       !
-                            CALL     phy_cst    ! Physical constants
-                            CALL     eos_init   ! Equation of state
-      IF( lk_c1d        )   CALL     c1d_init   ! 1D column configuration
-                            CALL     dom_cfg    ! Domain configuration
+                            CALL  phy_cst    ! Physical constants
+                            CALL  eos_init   ! Equation of state
+      IF( lk_c1d        )   CALL  c1d_init   ! 1D column configuration
+                            CALL  dom_cfg    ! Domain configuration
+      !
       !
       INQUIRE( FILE='coordinates.nc', EXIST = llexist )   ! Check if coordinate file exist
       !
-      IF( llexist )  THEN  ;  CALL  dom_init   !  compute the grid from coordinates and bathymetry
-      ELSE                 ;  CALL  dom_rea    !  read grid from the meskmask
+      IF( llexist )  THEN ;  CALL  dom_init   !  compute the grid from coordinates and bathymetry
+      ELSE                ;  CALL  dom_rea    !  read grid from the meskmask
       ENDIF
                             CALL  istate_init   ! ocean initial state (Dynamics and tracers)
 
-      IF( ln_nnogather )    CALL nemo_northcomms   ! Initialise the northfold neighbour lists (must be done after the masks are defined)
-
-      IF( ln_ctl        )   CALL prt_ctl_init   ! Print control
+      IF( ln_nnogather )    CALL  nemo_northcomms   ! Initialise the northfold neighbour lists (must be done after the masks are defined)
+
+      IF( ln_ctl       )    CALL  prt_ctl_init   ! Print control
 
                             CALL     sbc_init   ! Forcings : surface module
@@ -289,12 +290,10 @@
 
                             CALL tra_qsr_init   ! penetrative solar radiation qsr
-      IF( lk_trabbl     )   CALL tra_bbl_init   ! advective (and/or diffusive) bottom boundary layer scheme
+      IF( lk_trabbl   )     CALL tra_bbl_init   ! advective (and/or diffusive) bottom boundary layer scheme
 
                             CALL trc_nam_run    ! Needed to get restart parameters for passive tracers
                             CALL trc_rst_cal( nit000, 'READ' )   ! calendar
                             CALL dta_dyn_init   ! Initialization for the dynamics
-
                             CALL     trc_init   ! Passive tracers initialization
-                            CALL dia_ptr_init   ! Initialise diaptr as some variables are used 
       !                                         ! in various advection and diffusion routines
       IF(lwp) WRITE(numout,cform_aaa)           ! Flag AAAAAAA
Index: /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OPA_SRC/DOM/domain.F90
===================================================================
--- /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OPA_SRC/DOM/domain.F90	(revision 7521)
+++ /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OPA_SRC/DOM/domain.F90	(revision 7522)
@@ -23,4 +23,5 @@
    USE dom_oce         ! domain: ocean
    USE sbc_oce         ! surface boundary condition: ocean
+   USE trc_oce         ! shared ocean-passive tracers variables
    USE phycst          ! physical constants
    USE closea          ! closed seas
@@ -97,20 +98,23 @@
       END DO
       !
-      IF( lk_vvl )           CALL dom_vvl_init ! Vertical variable mesh
-      !
-      IF( lk_c1d         )   CALL cor_c1d      ! 1D configuration: Coriolis set at T-point
-      !
-      !
-      hu(:,:) = 0._wp                          ! Ocean depth at U-points
-      hv(:,:) = 0._wp                          ! Ocean depth at V-points
-      ht(:,:) = 0._wp                          ! Ocean depth at T-points
-      DO jk = 1, jpkm1
-         hu(:,:) = hu(:,:) + fse3u_n(:,:,jk) * umask(:,:,jk)
-         hv(:,:) = hv(:,:) + fse3v_n(:,:,jk) * vmask(:,:,jk)
-         ht(:,:) = ht(:,:) + fse3t_n(:,:,jk) * tmask(:,:,jk)
-      END DO
-      !                                        ! Inverse of the local depth
-      hur(:,:) = 1._wp / ( hu(:,:) + 1._wp - umask_i(:,:) ) * umask_i(:,:)
-      hvr(:,:) = 1._wp / ( hv(:,:) + 1._wp - vmask_i(:,:) ) * vmask_i(:,:)
+      IF( lk_c1d )           CALL cor_c1d      ! 1D configuration: Coriolis set at T-point
+      !
+      IF( .NOT.lk_offline ) THEN
+        !
+        IF( lk_vvl )         CALL dom_vvl_init ! Vertical variable mesh
+        !
+        hu(:,:) = 0._wp                          ! Ocean depth at U-points
+        hv(:,:) = 0._wp                          ! Ocean depth at V-points
+        ht(:,:) = 0._wp                          ! Ocean depth at T-points
+        DO jk = 1, jpkm1
+           hu(:,:) = hu(:,:) + fse3u_n(:,:,jk) * umask(:,:,jk)
+           hv(:,:) = hv(:,:) + fse3v_n(:,:,jk) * vmask(:,:,jk)
+           ht(:,:) = ht(:,:) + fse3t_n(:,:,jk) * tmask(:,:,jk)
+        END DO
+        !                                        ! Inverse of the local depth
+        hur(:,:) = 1._wp / ( hu(:,:) + 1._wp - umask_i(:,:) ) * umask_i(:,:)
+        hvr(:,:) = 1._wp / ( hv(:,:) + 1._wp - vmask_i(:,:) ) * vmask_i(:,:)
+        !
+      ENDIF
 
                              CALL dom_stp      ! time step
Index: /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsbc.F90
===================================================================
--- /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsbc.F90	(revision 7521)
+++ /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsbc.F90	(revision 7522)
@@ -263,10 +263,4 @@
       ENDIF
 
-      ! set the number of level over which river runoffs are applied 
-      ! online configuration : computed in sbcrnf
-      IF( lk_offline ) THEN
-        nk_rnf(:,:) = 1
-        h_rnf (:,:) = e3t_0(:,:,1)
-      ENDIF
 
       ! dust input from the atmosphere
